
<?php
/*---------------------------------------------------+
| PHP-Fusion 6 Content Management System
+----------------------------------------------------+
| Copyright  2002 - 2005 Nick Jones
| http://www.php-fusion.co.uk/
+----------------------------------------------------+
| Released under the terms & conditions of v2 of the
| GNU General Public License. For details refer to
| the included gpl.txt file or visit http://gnu.org
+----------------------------------------------------+
| CSS_QS Coded by PyschoBirdMan
| David Andrews 2006
+----------------------------------------------------*/
require_once "../../maincore.php";
require_once BASEDIR."subheader.php";
require_once ADMIN."navigation.php";

if (!checkRights("IP")) { header("Location:../../index.php"); exit; }

// Check if locale file is available matching the current site locale setting.
if (file_exists(INFUSIONS."css_qs_panel/locale/".$settings['locale'].".php")) {
	// Load the locale file matching the current site locale setting.
	include INFUSIONS."css_qs_panel/locale/".$settings['locale'].".php";
} else {
	// Load the infusion's default locale file.
	include INFUSIONS."css_qs_panel/locale/English.php";
}

if (isset($_GET['action']))
{
  $action = $_GET['action'];
  $id = $_GET['id'];
  if (isset($_GET['neworder']))
  {
  $neworder = $_GET['neworder'];
  }
}
else
{
  $action = "";
}

switch ($action){
  case "Remove":
  $display = Remove_Server($id);
  $display = "<tr><td colspan='7' class='tbl2'>".$display."</td></tr>";
  break;
  case "Edit":
  // not yet implemented
  break;
  case "mvup":
  move_order_up($id,$neworder);
  @redirect ("css_qs_admin.php");
  break;
  case "mvdown":
  move_order_down($id,$neworder);
  @redirect ("css_qs_admin.php");
}

if (isset($_POST['submit']))
{
	foreach($_POST as $key=>$value) 
  		{
		  $$key = $value;
	    }
	$Error_Display = "";
	$Error_Display = validate_entry($server_type,$server_name,$ip1,$ip2,$ip3,$ip4,$server_port);
	If ($Error_Display != "")
	{  
	  $Error_Display = "<tr><td colspan='7' class='tbl2'>".$Error_Display."</td></tr>";
	}
}

// Server Listing

$server_list = Admin_Server_List();

opentable($locale['CSS_QS_001']);

	echo " 
	<table width='100%' valign='top' cellpadding='1' cellspacing='1' class='tbl-border'>
	<tr>
	<td align='center' valign='middle' width='10' class='tbl2'></td>
	<td align='left' valign='middle' class='tbl2'>".$locale['CSS_QS_003']."</td>
	<td align='center' valign='middle' class='tbl2' width='150'>".$locale['CSS_QS_004']."</td>
	<td align='center' valign='middle' class='tbl2' width='100'>".$locale['CSS_QS_005']."</td>
	<td align='center' valign='middle' class='tbl2' colspan='2'>".$locale['CSS_QS_012']."</td>
	<td align='center' valign='middle' class='tbl2' width='200'>".$locale['CSS_QS_006']."</td>
	</tr>
	$server_list
	$display
	</table>
	";
		
closetable();
Echo "<BR>";

// Add Server Dialog

opentable($locale['CSS_QS_002']);


echo "<form name='add_server' method='post' action='css_qs_admin.php'>
	<table width='100%' valign='top' cellpadding='1' cellspacing='1' class='tbl-border'>
	$Error_Display
	<tr>
		<td class='tbl2' width='2%' align='right'>".$locale['CSS_QS_007']."</td>
		<td class='tbl2' colspan='3'>
			<select size='1' class='tbl2' name='server_type'>
				<option value='Counter Strike Source'>Counter Strike Source</option>
				<option value='CounterStrike 1.6'>CounterStrike 1.6</option>
				<option value='TeamSpeak'>TeamSpeak</option>
			</select>
		</td>
	</tr>
	<tr>
		<td class='tbl2' width='2%' align='right'>".$locale['CSS_QS_008']."</td>
		<td class='tbl2' colspan='3'>
			<input type='text' size='130' class='tbl2' name='server_name'>
		</td>
	</tr>
	<tr>
		<td class='tbl2' width='2%' align='right'>".$locale['CSS_QS_009']."</td>
		<td class='tbl2' width='5%'>
			<input type='text' class='tbl2' size='2' maxlength='3' name='ip1'>.
			<input type='text' class='tbl2' size='2' maxlength='3' name='ip2'>.
			<input type='text' class='tbl2' size='2' maxlength='3' name='ip3'>.
			<input type='text' class='tbl2' size='2' maxlength='3' name='ip4'>
		</td>
		<td class='tbl2' align='right' width='1%'>".$locale['CSS_QS_010']."</td>
		<td class='tbl2' width='10%'>
			<input type='text' class='tbl2' size='6' maxlength='8' name='server_port'>
		</td>
	</tr>
	<tr>
		<td class='tbl2' align='left' width='100%' colspan='4'>
			<input type='submit' class='button' value='".$locale['CSS_QS_002']."' name='submit'>&nbsp;
			<input type='reset' class='button' value='".$locale['CSS_QS_011']."'>
		</td>
	</tr>
	</table>
	</Form>	";
closetable();

echo "</td>\n";
require_once BASEDIR."footer.php";

//Functions

Function validate_entry($type,$name,$ip1,$ip2,$ip3,$ip4,$port)
{
  global $db_prefix;

  $error_output = "";
  // Check everything is populated
  if (strlen($name) <= 0) { $error_output .= "Please fill in server Name<BR>"; } 
  if (strlen($ip1) <= 0 || !isDigits($ip1) || $ip1 <= 0 || $ip1 >= 255) { $error_output .= "Please enter a number between 0 and 255 into field 1 of IP Address<BR>"; }
  if (strlen($ip2) <= 0 || !isDigits($ip2) || $ip2 <= 0 || $ip2 >= 255){ $error_output .= "Please enter a number between 0 and 255 into field 2 of IP Address<BR>"; }
  if (strlen($ip3) <= 0 || !isDigits($ip3) || $ip3 <= 0 || $ip3 >= 255){ $error_output .= "Please enter a number between 0 and 255 into field 3 of IP Address<BR>"; }
  if (strlen($ip4) <= 0 || !isDigits($ip4) || $ip4 <= 0 || $ip4 >= 255){ $error_output .= "Please enter a number between 0 and 255 into field 4 of IP Address<BR>"; }
  if (strlen($port) <= 0) { $error_output .= "Please enter Port Number."; }

  if ($error_output == "")
  {
    switch ($type) {
    case "Counter Strike Source":
    	 $image = "images/cstrike.gif";
    	 break;
	case "TeamSpeak":
		 $image = "images/tsicon.gif";
		 break;
	case "CounterStrike 1.6":
		 $image = "images/cstrike.gif";
		 break;
	}
    // Find out last order number
	$result = dbquery("SELECT * FROM ".$db_prefix."css_qs_servers ORDER BY css_qs_server_order DESC LIMIT 1");
	if (dbrows($result) != 0) { $data = dbarray($result); $neworder = $data['css_qs_server_order'] + 1; } else { $neworder = 1; }
		 	 
    $SQL = "INSERT INTO ".$db_prefix."css_qs_servers";
	$SQL .= "(css_qs_server_Name,css_qs_server_address,css_qs_server_port,css_qs_server_image,css_qs_server_type,css_qs_server_order) "; 
	$SQL .= "VALUES ('".$name."','".$ip1.".".$ip2.".".$ip3.".".$ip4."','".$port."','".$image."','".$type."','".$neworder."')";
	
	$result = dbquery($SQL);
	
	$error_output = "Added ".$name." Server Successfully.";

  }
 
  return $error_output;

}


Function Admin_Server_List()
{
  	global $locale;
	global $db_prefix;
	  
	$result = dbquery("SELECT * FROM ".$db_prefix."css_qs_servers ORDER BY css_qs_server_order ASC");
	$rows = dbrows($result);

	If ($rows != 0)
	{
	  $i=0;
	  while($data = dbarray($result)) 
	  {
	  $i++;
	  if ($rows != 1)
	  {
	      $up = $data['css_qs_server_order'] - 1;
	      $down  = $data['css_qs_server_order'] + 1;
	      if ($i == 1)
	      {
			$arrows = "<a href='css_qs_admin.php?action=mvdown&id=".$data['css_qs_server_id']."&neworder=".$down."'><img src='".THEME."images/down.gif' border='0'></a>";
		  }
		  elseif ($i < $rows)
		  {
		     $arrows = "<a href='css_qs_admin.php?action=mvup&id=".$data['css_qs_server_id']."&neworder=".$up."'><img src='".THEME."images/up.gif' border='0'><a href='css_qs_admin.php?action=mvdown&id=".$data['css_qs_server_id']."&neworder=".$down."'><img src='".THEME."images/down.gif' border='0'></a>";
		  }
		  else
		  {
		    $arrows = "<a href='css_qs_admin.php?action=mvup&id=".$data['css_qs_server_id']."&neworder=".$up."'><img src='".THEME."images/up.gif' border='0'>";
		  }  
		 } 
		 else
	  		{
	  			$arrows = "";  
	  		}
	  
	  $list .= "<tr><td align='center' valign='middle' class='tbl1' width='10'><img src='".$data['css_qs_server_image']."'></td>
	  				<td align='left' valign='middle' class='tbl1'>".$data['css_qs_server_Name']."</td>
	  				<td align='center' valign='middle' class='tbl1'>".$data['css_qs_server_address']."</td>
	  				<td align='center' valign='middle' class='tbl1'>".$data['css_qs_server_port']."</td>
	  				<td align='center' valign='middle' class='tbl1' width='40'>".$data['css_qs_server_order']."</td>";			
	  $list .=      "<td align='center' valign='middle' class='tbl1' width='30'>".$arrows."</td>";
	  $list .=		"<td align='center' valign='middle' class='tbl1'><a href='css_qs_admin.php?action=Remove&id=".$data['css_qs_server_id']."'>Remove</a></td></tr>";	
	}
	}	
	else
	{
	  $list =  "<tr><td align='center' valign='middle' colspan='7'>".$locale['CSS_QS_105']."</td></tr>";
	}
	
	return $list;
}

function remove_server($id)
{
  global $db_prefix;

  $result = dbquery("SELECT * FROM ".$db_prefix."css_qs_servers where css_qs_server_id =".$id);
  
  $data = dbarray($result);
  $remove_order = $data['css_qs_server_order'];
  
  $SQL = "DELETE FROM ".$db_prefix."css_qs_servers";
  $SQL .= " WHERE css_qs_server_id = ".$id;
  $result = dbquery($SQL);
  
  $result = dbquery("SELECT * FROM ".$db_prefix."css_qs_servers ORDER BY css_qs_server_order ASC");
  $rows = dbrows($result);
  
  if ($rows != 0)
  {
  	while($data = dbarray($result))
	  {
	   if ($data['css_qs_server_order']  > $remove_order) 
	   {
	    $new_order = $data['css_qs_server_order'] - 1; 
	    $SQL = "UPDATE ".$db_prefix."css_qs_servers ";
		$SQL .= "SET css_qs_server_order =".$new_order;
		$SQL .= " where css_qs_server_id =".$data['css_qs_server_id'];
	   	$result_1 = dbquery($SQL);
	   }
	  }  
  }
  
  
  return "Server Removed";
  
}

function isDigits($element) {
  return !preg_match ("/[^0-9]/", $element);
}

function move_order_up($id,$neworder)
{
  global $db_prefix;
  $data = dbarray(dbquery("SELECT * FROM ".$db_prefix."css_qs_servers WHERE css_qs_server_order=".$neworder));
  $SQL = "UPDATE ".$db_prefix."css_qs_servers SET css_qs_server_order=$neworder+1";
  $SQL .= " WHERE css_qs_server_order=".$data['css_qs_server_order'];
  
  $result = dbquery($SQL);
  $SQL = "UPDATE ".$db_prefix."css_qs_servers SET css_qs_server_order=$neworder";
  $SQL .= " WHERE css_qs_server_id=".$id;
  $result = dbquery($SQL);
}

function move_order_down($id,$neworder)
{
    global $db_prefix;
    $data = dbarray(dbquery("SELECT * FROM ".$db_prefix."css_qs_servers WHERE css_qs_server_order=".$neworder));
	$SQL = "UPDATE ".$db_prefix."css_qs_servers SET css_qs_server_order=$neworder-1";
  	$SQL .= " WHERE css_qs_server_order=".$data['css_qs_server_order'];
  	$result = dbquery($SQL);
  	$SQL = "UPDATE ".$db_prefix."css_qs_servers SET css_qs_server_order=$neworder";
  	$SQL .= " WHERE css_qs_server_id=".$id; 
  	$result = dbquery($SQL);
}
?>