<?php
/*---------------------------------------------------+
| PHP-Fusion 6 Content Management System
+----------------------------------------------------+
| Copyright  2002 - 2005 Nick Jones
| http://www.php-fusion.co.uk/
+----------------------------------------------------+
| Released under the terms & conditions of v2 of the
| GNU General Public License. For details refer to
| the included gpl.txt file or visit http://gnu.org
+----------------------------------------------------*/

if (!defined("IN_FUSION") || !checkrights("I")) { header("Location: ../../index.php"); exit; }

// Check if locale file is available matching the current site locale setting.
if (file_exists(INFUSIONS."css_qs_panel/locale/".$settings['locale'].".php")) {
	// Load the locale file matching the current site locale setting.
	include INFUSIONS."css_qs_panel/locale/".$settings['locale'].".php";
} else {
	// Load the infusion's default locale file.
	include INFUSIONS."css_qs_panel/locale/English.php";
}

// Infusion general information
$inf_title = $locale['CSS_QS_TITLE'];
$inf_description = $locale['CSS_QS_DESC'];
$inf_version = "0.4";
$inf_developer = "David Andrews";
$inf_email = "andrewd02@cpwplc.com";
$inf_weburl = "http://www.tgc-source.co.uk";

$inf_folder = "css_qs_panel"; 
$inf_admin_image = ""; 
$inf_admin_panel = "css_qs_admin.php";

$inf_newtables = 1; // Number of new db tables to create or drop.
$inf_insertdbrows = 1; // Numbers rows added into created db tables.
$inf_altertables = 0; // Number of db tables to alter (upgrade).
$inf_deldbrows = 0; // Number of db tables to delete data from.

$inf_newtable_[1] = "css_qs_servers (
`css_qs_server_id` smallint(5) unsigned NOT NULL auto_increment,
`css_qs_server_Name` varchar(255) NOT NULL default '',
`css_qs_server_address` varchar(255) NOT NULL default '',
`css_qs_server_port` varchar(255) NOT NULL default '',
`css_qs_server_type` varchar(255) NOT NULL default '',
`css_qs_server_image` varchar(255) NOT NULL default '',
`css_qs_server_order` smallint(5) unsigned NOT NULL,
PRIMARY KEY (`css_qs_server_id`)
) TYPE=MyISAM;";

// Tables to remove on Defusion
$inf_droptable_[1] = "css_qs_servers";
?>